c     Created by Mahdi Esmaily Moghadam 05-25-2011
c     Please report any problem to mesmaily@ucsd.edu, memt63@yahoo.com

      MODULE COM

      LOGICAL pCorr, qCorr

      INTEGER nUnknowns, nDirichletSrfs, nNeumannSrfs, nXprint,
     2 nptsElvmax


      REAL(8) pConv, qConv

      INTEGER, ALLOCATABLE :: srfToXPtr(:), srfToXdPtr(:)

      REAL(8), ALLOCATABLE :: QNeumann(:,:), PDirichlet(:,:), offset(:),
     2   Xprint(:)

c Data for storing the input pressure
      REAL(8), ALLOCATABLE :: timesInletPressure(:)
      REAL(8), ALLOCATABLE :: inletPressures(:)
      INTEGER nInletPressureSteps

c Data for storing the input pressure
      REAL(8), ALLOCATABLE :: timesPim(:)
      REAL(8), ALLOCATABLE :: Pim(:)
      INTEGER nPimSteps

      END MODULE COM

c Subroutine to read input files
      SUBROUTINE READIFILE(unit, fname, t, x, dims)
      INTEGER :: unit
      INTEGER :: dims
      CHARACTER(*) :: fname
      REAL(8) :: t(dims)
      REAL(8) :: x(dims)
      REAL(8) :: curT, curX
      INTEGER :: IOstatus
      INTEGER :: nlines
  
c      INTENT(INOUT) t
c      INTENT(INOUT) x

      OPEN(unit, file = fname)
      nlines = 0
      DO
          READ(unit,*,IOSTAT=IOstatus) curT, curX
          IF (IOstatus > 0)  THEN
              PRINT *, 'ERROR in reading file'
              ELSE IF (IOstatus < 0) THEN
                 EXIT
              ELSE
                  nlines = nlines + 1
                  t(nlines) = curT
                  x(nlines) = curX
              END IF
      END DO
      CLOSE(unit)

      END SUBROUTINE READIFILE

      SUBROUTINE COUNTILINES(unit, fname, nlines)
      INTEGER :: unit
      CHARACTER(*) :: fname
      INTEGER :: nlines
      INTEGER :: IOstatus
      REAL(8) :: curT, curX

      INTENT(INOUT) nlines

      OPEN(unit, file = fname)
      nlines = 0
      DO
          READ(unit,*,IOSTAT=IOstatus) curT, curX
          IF (IOstatus > 0)  THEN
              PRINT *, 'ERROR in reading file'
          ELSE IF (IOstatus < 0) THEN
              EXIT
          ELSE
              nlines = nlines + 1
          END IF
      END DO
      CLOSE(unit)

      END SUBROUTINE COUNTILINES
